﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace WHDGExample
{
    public partial class Test : System.Web.UI.Page
    {        

        protected void Page_Load(object sender, EventArgs e)
        {
            BindGrid();
        }

        protected void BindGrid()
        {
            IList<Employee> repository;
         
            if (null == Session["repository"])
            {
                // Create a new Fake-Repository as a DB replacement
                repository = new List<Employee>();
                Employee e1 = new Employee("Kevin", "Developer", 5000);
                Employee e2 = new Employee("Stephan", "Developer", 6000);
                Employee e3 = new Employee("David", "Manager", 12000);
                repository.Add(e1);
                repository.Add(e2);
                repository.Add(e3);

                // Store Fake-Repository in session
                Session["repository"] = repository;
            }
            else
            {
                // Load Fake-Repository from session
                repository = (List<Employee>)Session["repository"];
            }

            // Fill DataSet with the Fake-Repository data
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            dt.Columns.Add("ID", typeof(Guid));
            dt.Columns.Add("Name", typeof(String));
            dt.Columns.Add("Position", typeof(String));
            dt.Columns.Add("Salary", typeof(int));

            foreach (Employee e in repository)
            {
                dt.Rows.Add(e.ID, e.Name, e.Position, e.Salary);
            }
                       
            ds.Tables.Add(dt);

            // Bind to DataGrid
            WebHierarchicalDataGrid1.DataSource = ds;
            WebHierarchicalDataGrid1.DataBind();
        }

        protected void WebHierarchicalDataGrid1_RowUpdating(object sender, Infragistics.Web.UI.GridControls.RowUpdatingEventArgs e)
        {
            int index = e.Row.Index;
            int newSalary = Int32.Parse(e.Values["Salary"].ToString());

            List<Employee> repository = (List<Employee>)Session["repository"];
            repository.ElementAt(index).Salary = newSalary;
            Session["repository"] = repository;

            BindGrid();         

        }
    }
}